/*    
	th_dnh_archiver - A compresser/decompresser for Danmakufu's compression format
	Copyright (C) 2010 Legend_Bird

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package com.x10hosting.nanohatakamachi.th_dnh.archiver;

import java.io.*;
 
public class NDataInputStream extends FilterInputStream /*implements DataInput*/ {
	//Does not implment DataInput- that interface is for big endian stuff!
	//In fact, even if it did, it wouldn't be considered one...
	
	//Yes, I know that LEDataInputStream exists. No, I will not use it because
	//of the restriction on military usage, which would prevent me from
	//licencing this under the GPL.	
	protected InputStream is;
	
	public NDataInputStream(InputStream is) {
		super(is);
		this.is=is;
	}
	
	public boolean readBoolean() throws IOException {return is.read()==1;}
	public byte readByte() throws IOException {return (byte)is.read();}	
	public short readShort() throws IOException {return (short)(is.read()+is.read()*8);}
	public char readChar() throws IOException {return (char)(is.read()+is.read()*(int)Math.pow(2,8));}
	public int readInt() throws IOException {return is.read()+is.read()*(int)Math.pow(2,8)+is.read()*(int)Math.pow(2,16)+is.read()*(int)Math.pow(2,24);}
	public long readLong() throws IOException {return (long)(is.read())+(long)(is.read()*(int)Math.pow(2,8))+(long)(is.read()*(int)Math.pow(2,16))+(long)(is.read()*(int)Math.pow(2,24))+(long)(is.read()*(int)Math.pow(2,32))+(long)(is.read()*(int)Math.pow(2,40))+(long)(is.read()*(int)Math.pow(2,48))+(long)(is.read()*(int)Math.pow(2,56));}
	public float readFloat() throws IOException {return Float.intBitsToFloat(readInt());}
	public double readDouble() throws IOException {return Double.longBitsToDouble(readLong());}
	public String readUTF() throws IOException {
		//FIXME Don't call on Eirin for help.
		DataInputStream eirineirinhelpmeeirin = new DataInputStream(is);
		return eirineirinhelpmeeirin.readUTF();
	}

	public byte[] readBytes(int l) throws IOException{
		byte[] a = new byte[l];
		for(int i=0;i<l;i++){
			a[i]=(byte)is.read();
		}
		return a;
	}
	public void readBytes(byte[] b) throws IOException{
		in.read(b);
	}
}
