/*    
	th_dnh_archiver - A compresser/decompresser for Danmakufu's compression format
	Copyright (C) 2010 Legend_Bird

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package com.x10hosting.nanohatakamachi.th_dnh.archiver;
 
import java.io.*;

public class NDataOutputStream extends FilterOutputStream /*implements DataOutput*/ {
	//Does not implment DataOutput- that interface is for big endian stuff!
	
	//Yes, I know that LEDataOutputStream exists. No, I will not use it because
	//of the restriction on military usage, which would prevent me from
	//licencing this under the GPL.
	protected OutputStream os;
	
	public NDataOutputStream(OutputStream os) {
		super(os);
		this.os=os;
	}
	
	public void writeBoolean(boolean b) throws IOException {os.write(b?1:0);}
	public void writeByte(int i) throws IOException {write(i);}	
	public void writeShort(int i) throws IOException {os.write(i);os.write(i>>8);}
	public void writeChar(int i) throws IOException {writeShort(i);}
	public void writeInt(int i) throws IOException {os.write(i);os.write(i>>8);os.write(i>>16);os.write(i>>24);}
	public void writeLong(long i) throws IOException {os.write((byte)i);os.write((byte)i>>8);os.write((byte)i>>16);os.write((byte)i>>24);os.write((byte)i>>32);os.write((byte)i>>40);os.write((byte)i>>48);os.write((byte)i>>56);}

	public void writeFloat(float f) throws IOException {writeInt(Float.floatToIntBits(f));}
	public void writeDouble(double d) throws IOException {writeLong(Double.doubleToLongBits(d));}
	public void writeUTF(String s) throws IOException {
		//FIXME Don't call on Eirin for help.
		DataOutputStream eirineirinhelpmeeirin = new DataOutputStream(os);
		eirineirinhelpmeeirin.writeUTF(s);
	}

	public void writeBytes(String s) throws IOException {
		char[] a = s.toCharArray();
		for(int i=0;i<a.length;i++){
			os.write(a[i]);
		}
	}
}
